// EncryptDecryptAES128ECB.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#pragma comment( lib, "Crypt32.lib" )	// CryptBinaryToStringA(), CryptStringToBinaryA()
#include <windows.h>
#include <wincrypt.h>
#include <stdlib.h>	// malloc()
#include <assert.h>
#include <conio.h>	// _getch()

#define MY_ENCRYPT_ALGORITHM		CALG_AES_128
#define MY_ENCRYPT_KEYLENGTH		128
#define MY_ENCRYPT_PADDINGMODE		PKCS5_PADDING
#define MY_ENCRYPT_CRYPTMODE		CRYPT_MODE_ECB

// Í^@̌㏈
static
void PostCryptString( HCRYPTPROV* phCryptProv,
	HCRYPTKEY* phCryptKey )
{
	if( *phCryptKey )
	{
		CryptDestroyKey( *phCryptKey );
		*phCryptKey = NULL;
	}
	if( *phCryptProv )
	{
		CryptReleaseContext( *phCryptProv, 0 );
		*phCryptProv = NULL;
	}
}

// Í^@̑O
static
bool PreCryptString( const char* pszKey,
	HCRYPTPROV* phCryptProv,
	HCRYPTKEY* phCryptKey )
{
	// AEgvbg̏
	*phCryptProv = NULL;
	*phCryptKey = NULL;

	// Cvbg̃`FbN
	if( NULL == pszKey )
	{
		return false;
	}
	DWORD dwSizeKey = (DWORD)( strlen( pszKey ) * sizeof( char ) );
	if( 0 == dwSizeKey )
	{
		return false;
	}

	// ÍvoC_̎擾
	// ÍvoC_ƂāAuMicrosoft Enhanced RSA and AES Cryptographic Providervw
	// ÍvoC_ƂāAuPROV_RSA_AESvw
	if( !CryptAcquireContext( phCryptProv, NULL, MS_ENH_RSA_AES_PROV, PROV_RSA_AES, 0 ) )
	{
		goto LABEL_ERROR;
	}

	// nbVIuWFNg̍쐬
	HCRYPTHASH hCryptHash = NULL;
	if( !CryptCreateHash( *phCryptProv, CALG_MD5, 0, 0, &hCryptHash ) )
	{
		goto LABEL_ERROR;
	}

	// nbVIuWFNgɁAnbVl߂錳ƂȂf[^̒ǉ
	if( !CryptHashData( hCryptHash, (BYTE*)pszKey, dwSizeKey, 0 ) )
	{
		goto LABEL_ERROR;
	}

	// nbVIuWFNgÍL[̎擾
	// ŚA16rbg[ɂA16rbgŃL[̃rbgw肷B
	if( !CryptDeriveKey( *phCryptProv, MY_ENCRYPT_ALGORITHM, hCryptHash, MY_ENCRYPT_KEYLENGTH << 16, phCryptKey ) )
	{
		goto LABEL_ERROR;
	}

	// pfBO[h
	DWORD dwPaddingMode = MY_ENCRYPT_PADDINGMODE;
	if( !CryptSetKeyParam( *phCryptKey, KP_PADDING, (BYTE*)&dwPaddingMode, 0 ) )
	{
		goto LABEL_ERROR;
	}

	// Í[h
	DWORD dwCryptMode = MY_ENCRYPT_CRYPTMODE;
	if( !CryptSetKeyParam( *phCryptKey, KP_MODE, (BYTE*)&dwCryptMode, 0 ) )
	{
		goto LABEL_ERROR;
	}

	if( hCryptHash )
	{
		CryptDestroyHash( hCryptHash );
	}
	return true;

LABEL_ERROR:
	if( hCryptHash )
	{
		CryptDestroyHash( hCryptHash );
	}
	PostCryptString( phCryptProv, phCryptKey );
	return false;
}

// ̈Í
bool EncryptString( const char* pszSource,
	const char* pszKey,
	BYTE** ppbyteDest,
	DWORD* pdwSizeDest )
{
	// AEgvbg̏
	*ppbyteDest = NULL;
	*pdwSizeDest = 0;

	// Cvbg̃`FbN
	if( NULL == pszSource
		|| NULL == pszKey )
	{
		return false;
	}

	// ϐ
	HCRYPTPROV hCryptProv = NULL;
	HCRYPTKEY hCryptKey = NULL;

	// Í^@̑O
	if( !PreCryptString( pszKey, &hCryptProv, &hCryptKey ) )
	{
		return false;
	}

	// obt@[m
	DWORD dwSizeSource = (DWORD)( strlen( pszSource ) * sizeof( char ) );
	if( 0 == dwSizeSource )
	{
		goto LABEL_ERROR;
	}
	DWORD dwSizeBuffer = dwSizeSource + 100;	// obt@[TCY̓\[Xi16ȏHj̈mۂB
	BYTE* pbyteBuffer = (BYTE*)malloc( dwSizeBuffer );
	memset( pbyteBuffer, 0x00, dwSizeBuffer );	// [߁B
	memcpy( pbyteBuffer, pszSource, dwSizeSource );	// Í镶̃oCgz

	// Í
	DWORD dwSize = dwSizeSource;
	if( !CryptEncrypt( hCryptKey, 0, TRUE, 0, pbyteBuffer, &dwSize, dwSizeBuffer ) )
	{
		goto LABEL_ERROR;
	}

	// AEgvbgɑ
	*ppbyteDest = pbyteBuffer;
	*pdwSizeDest = dwSize;	// dwSizéACryptEncrypt()ŁAÍʃf[^TCYɂȂĂB

	PostCryptString( &hCryptProv, &hCryptKey );
	return true;

LABEL_ERROR:
	if( pbyteBuffer ) { free( pbyteBuffer ); }
	PostCryptString( &hCryptProv, &hCryptKey );
	return false;
}

// ̕
bool DecryptString( const BYTE* pbyteSource,
	const DWORD dwSizeSource,
	const char* pszKey,
	char** ppszDest )
{
	// AEgvbg̏
	*ppszDest = NULL;

	// Cvbg̃`FbN
	if( NULL == pbyteSource
		|| NULL == pszKey )
	{
		return false;
	}

	// ϐ
	HCRYPTPROV hCryptProv = NULL;
	HCRYPTKEY hCryptKey = NULL;

	// Í^@̑O
	if( !PreCryptString( pszKey, &hCryptProv, &hCryptKey ) )
	{
		return false;
	}

	// obt@[m
	if( 0 == dwSizeSource )
	{
		goto LABEL_ERROR;
	}
	DWORD dwSizeBuffer = dwSizeSource + 100;	// obt@[TCY̓\[Xi16ȏHj̈mۂB
	char* pszBuffer = (char*)malloc( dwSizeBuffer );
	memset( pszBuffer, 0x00, dwSizeBuffer );	// [߁B
	memcpy( pszBuffer, pbyteSource, dwSizeSource );

	// 
	DWORD dwSize = dwSizeSource;
	if( !CryptDecrypt( hCryptKey, 0, TRUE, 0, (BYTE*)pszBuffer, &dwSize ) )
	{
		goto LABEL_ERROR;
	}

	// ̏I[Ɂu\0vt
	pszBuffer[dwSize / sizeof( char )] = '\0';	// dwSizéACryptEncrypt()ŁAʃf[^TCYɂȂĂB

	// AEgvbgɑ
	*ppszDest = pszBuffer;

	PostCryptString( &hCryptProv, &hCryptKey );
	return true;

LABEL_ERROR:
	if( pszBuffer ) { free( pszBuffer ); }
	PostCryptString( &hCryptProv, &hCryptKey );
	return false;
}

// oCgz16iɕϊ
char* ByteArray2HexString( BYTE* pbyteSource, DWORD dwSizeSource )
{
	DWORD dwSizeBuffer = 0;
	CryptBinaryToStringA( pbyteSource, dwSizeSource, CRYPT_STRING_HEXRAW | CRYPT_STRING_NOCRLF, NULL, &dwSizeBuffer );
	char* pszString = (char*)malloc( dwSizeBuffer );	// I[񕪑m
	CryptBinaryToStringA( pbyteSource, dwSizeSource, CRYPT_STRING_HEXRAW | CRYPT_STRING_NOCRLF, pszString, &dwSizeBuffer );
	return pszString;
}

// 16ioCgzɕϊ
void HexString2ByteArray( char* pszHexString, BYTE** ppbyteDest, DWORD* pdwSizeDest )
{
	DWORD dwSizeBuffer = 0;
	CryptStringToBinaryA( pszHexString, strlen( pszHexString ), CRYPT_STRING_HEXRAW, NULL, &dwSizeBuffer, 0, 0 );
	BYTE* pbyteBuffer = (BYTE*)malloc( dwSizeBuffer );
	CryptStringToBinaryA( pszHexString, strlen( pszHexString ), CRYPT_STRING_HEXRAW, pbyteBuffer, &dwSizeBuffer, 0, 0 );
	*ppbyteDest = pbyteBuffer;
	*pdwSizeDest = dwSizeBuffer;
}

int main()
{
	// ϐ
	char	szString[] = "abcdACEGىIG";
	char	szKey[] = "hiramine.com";

	BYTE* pbyteEncrypted = NULL;
	DWORD dwSizeEncrypted = 0;
	char* pszDecrypted = NULL;

	printf( "ÍO : %s\n", szString );

	// ̈Í
	if( !EncryptString( szString, szKey, &pbyteEncrypted, &dwSizeEncrypted ) )
	{
		assert( !"̈ÍɎs" );
		return -1;
	}
	assert( pbyteEncrypted );

	// oCgz16iɕϊ
	char* pszEncrypted = ByteArray2HexString( pbyteEncrypted, dwSizeEncrypted );
	printf( "Í㕶 : %s\n", pszEncrypted );

	// 16ioCgzɕϊ
	BYTE* pbyteEncrypted2 = NULL;
	DWORD dwSizeEncrypted2 = 0;
	HexString2ByteArray( pszEncrypted, &pbyteEncrypted2, &dwSizeEncrypted2 );

	// Íꂽf[^̕
	if( !DecryptString( pbyteEncrypted2, dwSizeEncrypted2, szKey, &pszDecrypted ) )
	{
		free( pbyteEncrypted );
		assert( !"Íꂽf[^̕Ɏs" );
		return -1;
	}
	assert( pszDecrypted );
	free( pbyteEncrypted );
	free( pszEncrypted );
	free( pbyteEncrypted2 );
	printf( "㕶 : %s\n", pszDecrypted );

	if( 0 == strcmp( szString, pszDecrypted ) )
	{
		printf( "ÍOƕ㕶́AvI\n" );
	}
	else
	{
		printf( "ÍOƕ㕶́AsvI\n" );
	}

	free( pszDecrypted );

	_getch();

	return 0;
}
